/*
 *  @Interface Aluno
 *
 *  Na interface definiremos apenas a assinatura dos mtodos.
 *  Todos eles devem ser deixado abstratos indicando que a sua implementao
 *  ficar pendente. Assim podemos indicar que o mtodo existir sem que
 *  precisemos nos preocupar, neste momento, com a implementao.
 *
 *  Defino que os mtodo existem e como ser o acesso a eles mas no defino ainda
 *  como eles sero implementados
 */
interface Aluno
{
	public abstract void atribuir(String Nome, double N1, double N2, double N3);
	public abstract String qualNome();
	public abstract double qualNota(int Qual);
	public abstract double qualMedia();
	
}

/*
 *  A classe AlunoGrad vai implementar os mtodos que ficaram pendentes na interface
 *  Aluno. Todos os mtodos definidos na interface DEVEM ser implementados nesta classe
 *  respeitando as assinaturas l definidas.
 *
 *  Perceba que as propriedades so definidas apenas aqui
 */
class AlunoGrad implements Aluno
{
	private String Nome;
	private double Notas[] = new double[3]; // instanciando o vetor de 3 posicoes
	
	public void atribuir(String N, double N1, double N2, double N3)
	{
		Nome = N;
		Notas[0] = N1;
		Notas[1] = N2;
		Notas[2] = N3;
	}
	
	public String qualNome()
	{
		return Nome;
	}
	
	public double qualNota(int Qual)
	{
		if ( (Qual>2) || (Qual<0)) return 0;
		return Notas[Qual];
	}
	
	/*
	 * Calculo da mdia Ponderada
	 */
	public double qualMedia()
	{
		return ((Notas[0] + 
		         Notas[1] * 2 + 
		         Notas[2] * 3
		        ) / 6
		       );
	}
}

/*
 *  A classe AlunoPos vai implementar os mtodos que ficaram pendentes na interface
 *  Aluno. Todos os mtodos definidos na interface DEVEM ser implementados nesta classe
 *  respeitando as assinaturas l definidas.
 *
 *  Perceba que as propriedades so definidas apenas aqui
 */
 
class AlunoPos implements Aluno
{
	private String Nome;
	private double Notas[] = new double[3]; // instanciando o vetor de 3 posicoes
	
	public void atribuir(String N, double N1, double N2, double N3)
	{
		Nome = N;
		Notas[0] = N1;
		Notas[1] = N2;
		Notas[2] = N3;
	}
	
	public String qualNome()
	{
		return Nome;
	}
	
	public double qualNota(int Qual)
	{
		if ( (Qual>2) || (Qual<0)) return 0;
		return Notas[Qual];
	}
	
	/*
	 * Calculo da mdia Aritmtica
	 */
	public double qualMedia()
	{
		return ((Notas[0] + 
		         Notas[1] + 
		         Notas[2] 
		        ) / 3
		       );
	}
}

class Principal
{
	public static void main(String Args[])
	{
		/*
		 *  Vamos declarar um objeto da interface Aluno e atribuir a ele uma
		 *  instncia da classe AlunoGrad
		 */
		Aluno MeuAluno = new AlunoGrad();
		
		
		MeuAluno.atribuir("Andreia",5.5,7.0,9.0);
		System.out.println("Dados de Aluno de Graduacao");
		System.out.println("------------------------------------------");
		System.out.println("Nome..... : " + MeuAluno.qualNome());
		System.out.println("1a.Nota.. : " + MeuAluno.qualNota(0));
		System.out.println("2a.Nota.. : " + MeuAluno.qualNota(1));
		System.out.println("3a.Nota.. : " + MeuAluno.qualNota(2));
		System.out.println("Media.... : " + MeuAluno.qualMedia());
		System.out.println("------------------------------------------");
		
		/*
		 * Agora vamos criar uma nova instncia sobre o mesmo objeto mas agora 
		 * usaremes uma instncia da classe ALlunoPos.
		 * Perceba na impressao da mdia que o valor  diferente mesmo os dados
		 * sendo iguais
		 */
		MeuAluno = new AlunoPos();
		MeuAluno.atribuir("Andreia",5.5,7.0,9.0);
		System.out.println("Dados de Aluno de Pos-Graduacao");
		System.out.println("------------------------------------------");
		System.out.println("Nome..... : " + MeuAluno.qualNome());
		System.out.println("1a.Nota.. : " + MeuAluno.qualNota(0));
		System.out.println("2a.Nota.. : " + MeuAluno.qualNota(1));
		System.out.println("3a.Nota.. : " + MeuAluno.qualNota(2));
		System.out.println("Media.... : " + MeuAluno.qualMedia());
		System.out.println("------------------------------------------");
		
		
	}
}